#ifndef __app_types__
#define __app_types__

//------------------------------------------------------------------------------
// Файл app_types.h - содержит элементы таблицы имен, определяющие назначение
// именованных программных объектов.
//------------------------------------------------------------------------------

#include <stdio.h>

//using namespace std;

//------------------------------------------------------------------------------
// Базовый класс, обобщающий назначение программных объектов.
class application 
{
public:
  // Вывод информации о назначении в указанный поток
  virtual void Out(FILE* of = stdout) = 0;
};


//------------------------------------------------------------------------------
// Скалярные типы, используемые в языке
enum scalType {INT_TYPE, FLOAT_TYPE} ;

//------------------------------------------------------------------------------
// Класс, определяющий переменную
class app_variable: public application
{
public:
  void Out(FILE* of = stdout);
  // Конструктор класса
  //  app_variable(scalType typ, int len, int addr):
  //	_typ(typ), _len(len), _addr(addr) {}

  // параметры переменной
  scalType _typ;   // скалярный тип элемента таблицы
  int	   _len;   // длина вектора ( = 0, если скаляр)
  int      _addr;  // адрес в физической памяти (только статической)
};

//------------------------------------------------------------------------------
// Класс, определяющий метку
class app_label: public application
{
public:
  void Out(FILE* of = stdout);
  // Конструктор класса
  app_label(bool dclFlag): wasDcl(dclFlag) {}
  bool wasDcl; // Флаг, определяющий объявление метки.
};

//------------------------------------------------------------------------------
#endif
