//------------------------------------------------------------------------------
// main.cpp - функция, активизирующая запуск распознавателя
//------------------------------------------------------------------------------

#include     <string.h>
#include     <stdio.h>

#include     "scanner_ext.h"
#include     "name_table_ext.h"

//------------------------------------------------------------------------------

void fprintlex(FILE*);   // тестовый вывод результатов работы сканера
bool scan_init(char*);   // начальная установка сканера (нужна только здесь)
void scan_destroy(void); // завершение работы сканера

bool Program(void);      // распознаватель правильной программы

//------------------------------------------------------------------------------

extern int erCounter; // Счетчик числа ошибок в обрабатываемой программе

//------------------------------------------------------------------------------

FILE  *outfil;

//------------------------------------------------------------------------------
int main(int argc, char** argv)
{
  if(argc != 3) {
    printf("\nIncorrect command format!\n");
    printf("\nYou must type: command sourced_file recived_file.\n");
    return 1;
  }

  outfil = fopen(argv[2], "w");
  line = 1; column = 0;

  if(!scan_init(argv[1])) return 2;
  
  // Осуществляется разбор программы с выдачей информации об успехе или неудаче
  if(Program() && erCounter==0 && AllLabelsDefined(table))
  {
    printf("Program is correct!\n");
  }
  else
  {
    printf("Invalid program!\n");
  }
  Out(table, outfil);
  
  scan_destroy();
  fclose(outfil);
  Clear(table);
  return 0;
} 

//------------------------------------------------------------------------------

