// Файл stlTable - содержит функции, определяющие работу с таблицей имен
/////////////////////////////////////////////////////////////////////////////

#include "name_table.h"

// Вывод таблицы имен в поток, закрепленный за файлом или на экран
// в зависимости от указания потока в качестве второго аргумента.
// По умолчанию осуществляется вывод в cout.
void Out(NameTable &table, FILE *os = stdout) {
	NameTable::iterator i;
	fprintf(os, "Table of names\n");
	for(i = table.begin(); i != table.end(); i++)
	{
		// Первый выводимый элемент - это имя
		fprintf(os, "%s: ", (*i).first.c_str());

		// Далее необходимо вывести назначение, которое может определять
		// переменную или метку.
		(*i).second->Out(os);

		// Перевод строки перед выводом следующего элемента таблицы имен.
		fprintf(os, "\n");


		//fprintf(os, "%s      %d\n", (*i).first.c_str(), (*i).second);
	}
	fprintf(os, "Size of Table = %d\n", int(table.size()));
}

// Проверка всех меток на наличие объявлений
bool AllLabelsDefined(NameTable &table)
{
	int bad_lab_counter = 0;
	NameTable::iterator i;
	for(i = table.begin(); i != table.end(); i++)
	{
		if(app_label* p_lab = dynamic_cast<app_label*>((*i).second))
		{
			// Наткнулись на имя метки
			// Проверяем метку на наличие объяления.
			if(!(p_lab->wasDcl))
			{
				// Метка оказаась не объявленной
				printf("CONTEX ERROR: label \"%s\" was not declared\n", 
					(*i).first.c_str());
				++bad_lab_counter;
			}
		}
	}
	if(bad_lab_counter) 
		return false;
	else
		return true;
}


// Очистка таблицы имен по окончании работы от назначений
void Clear(NameTable &table)
{
	NameTable::iterator i;
	for(i = table.begin(); i != table.end(); i++)
	{
		delete (*i).second;
	}
}