#ifndef __name_table__
#define __name_table__

//------------------------------------------------------------------------------
// Файл name_table.h - содержит описания типов и данных, 
// используемых функциями, работающими с таблицей имен
//------------------------------------------------------------------------------

//#include <iostream>
//#include <fstream>
//#include <iomanip>
#include <stdio.h>
#include <string>
#include <map>

using namespace std;

#include "app_types.h"

//------------------------------------------------------------------------------
// Элементы таблицы имен, определяющие назначение 
// именованных программных объектов.
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Упорщенное переопределение таблицы имен
typedef map<string, application*, less<string> > NameTable;

// Таблица имен, заданная в виде статической пременной,
// так как является единственной и внешней в данной
// семантической модели языка
NameTable table;

// Адрес памяти, используемой для размещения переменных
int glob_addr = 0;

#endif
